<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['oa:manage:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['oa:manage:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['oa:manage:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['oa:manage:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="manageDeptList" @selection-change="handleSelectionChange">
      <el-table-column type="index" width="50" />
      <el-table-column label="分管领导" align="center" prop="user.nickName" />
      <el-table-column label="分管部门" align="center" prop="deptName" />
      <el-table-column label="院内对接单位" align="center" prop="partyAName" width="600px" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['oa:manage:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['oa:manage:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改cmc领导分管对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="分管领导" prop="userId">
          <el-select v-model="form.userId" filterable clearable style="width:220px" :disabled="isSelect">
            <el-option v-for="item in userList" :key="item.userId" :label="item.nickName" :value="item.userId"
              v-if="item.userId > 0">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="分管部门" prop="deptId">
          <el-select v-model="form.deptId" filterable multiple clearable style="width:100%;">
            <el-option v-for="item in deptList" :key="item.deptId" :label="item.deptName" :value="item.deptId"
              v-if="item.deptId > 103 && item.deptId < 200">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="院内对接单位" prop="partyAId">
          <el-select v-model="form.partyAId" filterable multiple clearable style="width:100%;">
            <el-option v-for="item in partyAList" :key="item.partyAId" :label="item.partyAName" :value="item.partyAId"
              v-if="item.partyAName.startsWith('中国电建集团成都')">
            </el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listManageDept, getManageDept, delManageDept, addManageDept, updateManageDept } from "@/api/oa/manage/manageDept";
import { listPartyA } from "@/api/oa/partyA/partyA";

export default {
  name: "ManageDept",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // cmc领导分管表格数据
      manageDeptList: [],
      userList: [],
      deptList: [],
      partyAList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      isSelect: false,
      isAdd: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        userId: [
          { required: true, message: "分管领导不能为空", trigger: "change" }
        ],
        deptId: [
          { required: true, message: "分管部门不能为空", trigger: "change" }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getUserList();
    this.getDeptList();
    this.getPartyAList();
  },
  methods: {
    /** 查询cmc领导分管列表 */
    getList() {
      this.loading = true;
      listManageDept(this.queryParams).then(response => {
        this.manageDeptList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 查询用户列表
    getUserList() {
      this.userList = this.$store.state.user.userList;
    },
    // 查询部门列表
    getDeptList() {
      this.deptList = this.$store.state.user.deptList;
    },
    // 查询甲方单位列表
    getPartyAList() {
      listPartyA({ pageSize: 9999, pageNum: 1 }).then(res => {
        this.partyAList = res.rows
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.isSelect = false;
      this.isAdd = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        userId: null,
        deptId: null,
        partyAId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.userId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.isAdd = true;
      this.isSelect = false;
      this.open = true;
      this.title = "添加领导分管";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const userId = row.userId || this.ids
      getManageDept(userId).then(response => {
        this.form = response.data;
        if (this.form.deptId) {
          let deptId = [];
          for (let dept of this.form.deptId.split(',')) {
            deptId.push(Number(dept));
          }
          this.form.deptId = deptId;
        }
        if (this.form.partyAId) {
          let partyAId = [];
          for (let partyA of this.form.partyAId.split(',')) {
            partyAId.push(partyA);
          }
          this.form.partyAId = partyAId;
        }
        this.isSelect = true;
        this.isAdd = false;
        this.open = true;
        this.title = "修改领导分管";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (!this.isAdd) {
            this.form.deptId = this.formatArrayToString(this.form.deptId, ',') == '' ? undefined : this.formatArrayToString(this.form.deptId, ',');
            this.form.partyAId = this.formatArrayToString(this.form.partyAId, ',') == '' ? undefined : this.formatArrayToString(this.form.partyAId, ',');
            updateManageDept(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.isAdd = false;
              this.isSelect = false;
              this.getList();
            });
          } else {
            this.form.deptId = this.formatArrayToString(this.form.deptId, ',') == '' ? undefined : this.formatArrayToString(this.form.deptId, ',');
            this.form.partyAId = this.formatArrayToString(this.form.partyAId, ',') == '' ? undefined : this.formatArrayToString(this.form.partyAId, ',');
            addManageDept(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.isAdd = false;
              this.isSelect = false;
              this.getList();
            });
          }
        }
      });
    },
    formatArrayToString(str, splitStr) {
      let newStr = "";
      if (str) {
        newStr = str.join(splitStr)
      }
      return newStr
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const userIds = row.userId || this.ids;
      this.$modal.confirm('是否确认删除cmc分管领导为"' + this.getUserName(userIds) + '"的数据项？').then(function () {
        return delManageDept(userIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('oa/manageDept/export', {
        ...this.queryParams
      }, `manageDept_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
